package uebung05.logistics.storage;

import uebung05.logistics.NeedCollector;
import uebung05.logistics.quantities.FloatUnit;

public class FloatStorage implements FloatUnit{

    private float stored;
    private final FloatUnit unit;
    private final float max;

    public FloatStorage(float stored, FloatUnit unit, float max){
        this.stored = stored;
        this.unit = unit;
        this.max = max;
    }

    public float getStored(){
        return stored;
    }

    public FloatUnit getUnit(){
        return unit;
    }

    public float getMax(){
        return max;
    }

    @Override
    public String toString() {
        return "storage with "+ stored + " of " + max + " units of " + unit;
    }

    public float consume(float amount){
        
        float actualConsumed = Math.min(stored, amount);
        
        stored = stored - actualConsumed;

        return actualConsumed;
    }

    public void fill(float amount){
        if (stored+amount > max) {
            stored = max;
        } else {
            stored = stored + amount;
        }
    }

    public void fillUp(){
        stored = max;
    }

    public void reportNeed(NeedCollector collector){
        collector.add(max-stored, unit);
    }

}
